#!/usr/bin/perl
#
# Utility to browse mp3 entries
# Copyright (C) 1999-2000 Louise Youdale
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$LOCAL_CDDB = '/var/lib/cddbp/cddb';

# eoc

chdir $LOCAL_CDDB || die "chdir: $!";
opendir DIR, "." || die "opendir: $!";
@all_cats = grep !/^\.\.?$/, grep -d, readdir DIR;
closedir DIR;

foreach $cat (@all_cats) {
	print "$cat\n";

	chdir $cat || die "chdir: $!";
	opendir DIR, "." || die "opendir: $!";
	@files = grep -f, readdir DIR;
	closedir DIR;

	foreach $key (@files) {
		print "\t$key";
		parse_mp3 ($key);
		print "\t[" . $mp3_name{$key} . "]\n";
	}
	chdir "..";
}

sub parse_mp3 {
	my($file) = @_;

	open FILE, $file || die "open: $!";
	while (<FILE>) {
		s/[\r\n]//g;
		if (/^DTITLE=(.+)/) {
			$mp3_name{$file} = $1;
		} elsif (/^TTITLE(\d+)=(.+)/) {
			$mp3_track{$file}{$1} = $2;
		}
	}
	close FILE;
}

# eof
