#!/usr/bin/perl
#
# Utility to browse mp3 entries, requires pTk (perl Tk)
# Copyright (C) 1999-2000 Louise Youdale
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# 7 June 1999	jet@poboxes.com
# 14 June 1999	- added indicators in xpm
# 2 July 1999	- sorted artist names
# 14 may 2k     - added search facility, fixed track list undef

$LOCAL_CDDB = '/var/lib/cddbp/cddb';

# default values for checkboxes
$sort_artist = 0;
$sort_album = 0;
$sort_track = 1;

# eoc

use Tk;

$data{plus} = '/* XPM */
static char *plus[] = {
/* width height num_colors chars_per_pixel */
"    9     9           3          1",
/* colors */
". c #ffffff",
"# c #000000",
"o c #848284",
/* pixels */
"ooooooooo",
"o.......o",
"o...#...o",
"o...#...o",
"o.#####.o",
"o...#...o",
"o...#...o",
"o.......o",
"ooooooooo",};
';

$data{minus} = '/* XPM */
static char *minus[] = {
/* width height num_colors chars_per_pixel */
"    9     9           3          1",
/* colors */
". c #ffffff",
"# c #000000",
"o c #848284",
/* pixels */
"ooooooooo",
"o.......o",
"o.......o",
"o.......o",
"o.#####.o",
"o.......o",
"o.......o",
"o.......o",
"ooooooooo",};
';


# create window
# TODO: how to put several buttons into a grid space

$win{top} = MainWindow->new;
$widget{frame} = $win{top}->Frame->pack (-side => left, -expand => yes, -fill => both);
# search box
$widget{labels} = $win{top}->Label (-text => 'Search:')->pack;
$widget{enters} = $win{top}->Entry (-width => 10)->pack;
$widget{enters}->bind ('<Return>' => sub {search ();});
$widget{artist} = $win{top}->Checkbutton(-text => 'search artist', -variable => \$sort_artist)->pack (-anchor => w);
$widget{album} = $win{top}->Checkbutton(-text => 'search album', -variable => \$sort_album)->pack (-anchor => w);
$widget{track} = $win{top}->Checkbutton(-text => 'search track', -variable => \$sort_track)->pack (-anchor => w);

$widget{label1} = $widget{frame}->Label (-text => "Artist's/CD's");
Tk::grid ($widget{label1}, -column => 0, -row => 0, -sticky => w);
$widget{label2} = $widget{frame}->Label (-text => 'Tracks');
Tk::grid ($widget{label2}, -column => 1, -row => 0, -sticky => w);

$widget{mp3} = $widget{frame}->Scrolled (qw/HList 
		-separator \/ -width 30 -height 20 -scrollbars e -background white -itemtype text -indicator true/);
Tk::grid ($widget{mp3}, -column => 0, -row => 1, -sticky => nsew);
$widget{mp3}->configure (-browsecmd => sub { &update_pane if ($_[1] eq '0');},
			 -indicatorcmd => sub {&toggle_tree;});
$widget{cd} = $widget{frame}->Scrolled (qw/HList 
		-header 1 -columns 2 -width 40 -height 20 -scrollbars e -background white/);
#$widget{cd} = $widget{frame}->HList (qw/-header 1 -columns 2 -width 40 -height 20 -background white/);
Tk::grid ($widget{cd}, -column => 1, -row => 1, -sticky => nsew);

$widget{cd}->header ('create', 0, -text => 'Title');
$widget{cd}->header ('create', 1, -text => 'Category');

$widget{ok} = $win{top}->Button (-text => 'OK', 
				 -command => sub {$win{top}->destroy;}, 
				 -width => 10)->pack (-padx => 10, -pady => 5);
$widget{cancel} = $win{top}->Button (-text => 'Cancel', 
				     -command => sub {$win{top}->destroy;}, 
				     -width => 10)->pack (-padx => 10, -pady => 5);
$widget{stats} = $win{top}->Button (-text => 'Statistics...', 
				    -command => sub {stat_box ();}, 
				    -width => 10)->pack (-padx => 10, -pady => 10);

$widget{frame}->gridRowconfigure (0, -weight => 0);
$widget{frame}->gridRowconfigure (1, -weight => 1);
$widget{frame}->gridColumnconfigure (0, -weight => 1);
$widget{frame}->gridColumnconfigure (1, -weight => 1);

$bmp{plus}  = $win{top}->Pixmap (-data => $data{plus});
$bmp{minus} = $win{top}->Pixmap (-data => $data{minus});

# fill in window bits

chdir $LOCAL_CDDB || die "chdir: $!";
opendir DIR, '.' || die "opendir: $!";
@all_cats = grep !/^\.\.?$/, grep -d, readdir DIR;
closedir DIR;

# read all cddb entries and add to hash table
$i = 0;
foreach $cat (@all_cats) {
	chdir $cat || die "chdir: $!";
	opendir DIR, '.' || die "opendir: $!";
	@files = grep -f, readdir DIR;
	closedir DIR;

	foreach $key (@files) {
		$full = parse_mp3 ($key);
		$random{$full} = $i;
		my $j = 0;
		while ($track{$j}) {
			$random_track->{$i}->{$j} = $track{$j};
			$j++;
		}
		$i++;
	}
	chdir '..';
}

# add sorted cddb entries from hash table to tk widget
foreach $album (sort keys %random) {
	$album =~ /(.+)\/(.+)/;
	my $artist_name = $1;
	my $album_name = $2;

	if (!$artist{$artist_name}) {
		$widget{mp3}->add ($artist_name, -text => $artist_name);
		$widget{mp3}->indicator (create, $artist_name, -itemtype => imagetext, -image => $bmp{plus});
		$artist{$artist_name} = $album_name;

		$stat{artist}++;
	} else {
		$artist{$artist_name} .= "/$album_name";
	}

	$cat_list{$album} = $cat;

	my $i = 0;
	while ($track{$i}) {
		$track_list->{$album}->{$i} = $random_track->{$random{$album}}->{$i};
		$i++;
	}

	$widget{mp3}->add ("$artist_name/$album_name", -text => $album_name);
	$widget{mp3}->hide (entry, "$artist_name/$album_name");

	$stat{cd}++;
}

# tk loop and quit
MainLoop;
print "finish.\n";

# parse a cddb entry file

sub parse_mp3 {
	my($file) = @_;
	my $title, $artist_name, $album_name;
	
	undef %track;

	open FILE, $file || die "open: $!";
	while (<FILE>) {
		s/[\r\n]//g;
		if (/^DTITLE=(.+)/) {
			$title = $1;
			if ($title =~ /\s*(.*?)\s*\/\s*(.*)\s*/) {
				$artist_name = $1;
				$album_name = $2;
			} else {
				$artist_name = $album_name = $1;
			}
		} elsif (/^TTITLE(\d+)=(.+)/) {
			$track{$1} = $2;
		}
	}
	close FILE;

	return "$artist_name/$album_name";
}

# update rhs with track details (when lhs is selected)

sub update_pane {
	my $h = shift;
	my $artist, $album;

	if ($h =~ /(.*)\/(.*)/) {
		update_album ($h);
	} else {
		update_artist ($h);
	}
}

# expand / shrink tree
# TODO: howto have lines linking artists
# TODO: howto get indicator valign=middle

sub toggle_tree {
	my($tree, $w) = @_;

	return if ($w ne '<Activate>');

	if ($widget{mp3}->indicator (cget, $tree, -image) eq $bmp{plus}) {
# expand
		$widget{mp3}->indicator (configure, $tree, -image => $bmp{minus});
		foreach $key ($widget{mp3}->info (children, $tree)) {
			$widget{mp3}->show (entry, $key);
		}
	} else {
# shrink
		$widget{mp3}->indicator (configure, $tree, -image => $bmp{plus});
		foreach $key ($widget{mp3}->info (children, $tree)) {
			$widget{mp3}->hide (entry, $key);
		}
	}
}

# user selected an artist on lhs, display albums on rhs
# TODO: howto get width of widget minus scrollbar
# TODO: howto auto remove scrollbar

sub update_artist {
	my($full) = @_;

	$widget{cd}->delete (all);
	$widget{cd}->header (configure, 1, -text => 'Category');

	my $i = 0;
	foreach my $key (split ('/', $artist{$full})) {
		my $row = $widget{cd}->addchild ('');
		$widget{cd}->itemCreate ($row, 0, -text => $key);
		$widget{cd}->itemCreate ($row, 1, -text => $cat_list{"$full/$key"});
	}

	$widget{cd}->columnWidth (0, $widget{cd}->width - $widget{cd}->columnWidth (1) - 10);
}

# user selected an album on lhs, display tracks on rhs

sub update_album {
	my($full) = @_;

	$widget{cd}->delete (all);
	$widget{cd}->header (configure, 1, -text => 'Track');

	my $i = 0;
	while ($track_list->{$full}->{$i}) {
		my $row = $widget{cd}->addchild ('');
		$widget{cd}->itemCreate ($row, 0, -text => $track_list->{$full}->{$i});
		$widget{cd}->itemCreate ($row, 1, -text => $i++);
	}

	$widget{cd}->columnWidth (0, $widget{cd}->width - $widget{cd}->columnWidth (1) - 10);
}	

# display number of cds / categorys
#

sub stat_box {
	$win{top}->messageBox (-icon => 'info', 
			       -message => "$stat{artist} Artists\n$stat{cd} CDs", 
			       -title => 'Statistics',
			       -type => 'OK');
}

# search all artists, albums, tracks for text
#

sub search {
	my $msg = $widget{enters}->get;

	return if ($msg =~ /^\s*$/);

	$widget{cd}->delete (all);
	$widget{cd}->header (configure, 1, -text => 'Result');

#	print "search for \"$msg\"\n";
	my $result = 1;

# artist names
	foreach $artist_name (keys %artist) {
		if ($sort_artist && $artist_name =~ /\Q$msg/i) {
#			print "match - $artist_name\n";
			my $row = $widget{cd}->addchild ('');
			$widget{cd}->itemCreate ($row, 0, -text => $artist_name);
			$widget{cd}->itemCreate ($row, 1, -text => $result++);
		}
# album
if ($sort_album || $sort_track) {
		foreach my $album (split ('/', $artist{$artist_name})) {
			my $full = "$artist_name/$album";

			if ($sort_album && $album =~ /\Q$msg/i) {
#				print "match - $full\n";
				my $row = $widget{cd}->addchild ('');
				$widget{cd}->itemCreate ($row, 0, -text => $full);
				$widget{cd}->itemCreate ($row, 1, -text => $result++);
			}
# tracks
if ($sort_track) {
			my $i = 0;
			while ($track_list->{$full}->{$i}) {
				my $track = "$full/$track_list->{$full}->{$i}";
				if ($track_list->{$full}->{$i++} =~ /\Q$msg/i) {
#					print "match - $track\n";
					my $row = $widget{cd}->addchild ('');
					$widget{cd}->itemCreate ($row, 0, -text => $track);
					$widget{cd}->itemCreate ($row, 1, -text => $result++);
				}
			}
}
		}
}
	}

	if ($result eq 1) {
		my $row = $widget{cd}->addchild ('');
		$widget{cd}->itemCreate ($row, 0, -text => '<search returned no results>');
	}

	$widget{cd}->columnWidth (0, $widget{cd}->width - $widget{cd}->columnWidth (1) - 10);
}

# eof
